<div class="mat-table-wrapper">
    <!-- Material table foods -->
    <table mat-table [dataSource]="dataSource" class="table-foods" style="width: 100%"
        [ngClass]="{'table-products-big' : viewMode === 'big'}">
        <!-- Checkbox Column -->
        <ng-container *ngIf="selectionMode" matColumnDef="select">
            <th mat-header-cell *matHeaderCellDef>
                <mat-checkbox (change)="$event ? masterToggle() : null"
                    [checked]="selection.hasValue() && isAllSelected()"
                    [indeterminate]="selection.hasValue() && !isAllSelected()">
                </mat-checkbox>
            </th>
            <td mat-cell *matCellDef="let row">
                <mat-checkbox (click)="$event.stopPropagation()" (change)="$event ? onSelect(row) : null"
                    [checked]="selection.isSelected(row)">
                </mat-checkbox>
            </td>
        </ng-container>

        <!-- Undo action (to project) -->
        <ng-container *ngIf="undoAction" matColumnDef="undo">
            <th mat-header-cell *matHeaderCellDef></th>
            <td mat-cell *matCellDef="let row" (click)="undoProduct(row)" class="undo-cell">
                <mat-icon matTooltip="{{ 'actions.undo' | translate }}" [matTooltipPosition]="'after'">undo</mat-icon>
            </td>
        </ng-container>

        <!-- Name Column -->
        <ng-container matColumnDef="name">
            <th mat-header-cell *matHeaderCellDef> {{ 'products.table.name' | translate }}
            </th>
            <td mat-cell *matCellDef="let element" [ngClass]="{'pl-2': selectionMode}" class="position-relative">
                <div class="wrap-info">
                    <div *ngIf="viewMode === 'big'" class="wrap-image"
                        [style.backgroundImage]="'url('+ element.image +')'"></div>

                    <div class="wrap-name">
                        <span>{{element.name}} </span>
                        <mat-chip-listbox>
                            <mat-chip *ngIf="element.type" color="primary" selected>{{element.type | lowercase }}
                            </mat-chip>
                        </mat-chip-listbox>
                    </div>
                </div>
            </td>
        </ng-container>

        <!-- Brand Column -->
        <ng-container matColumnDef="brand">
            <th mat-header-cell *matHeaderCellDef > {{ 'products.table.brand' | translate }}
            </th>
            <td mat-cell *matCellDef="let element" class="brand-cell">
                <mat-chip *ngIf="element.brand" class="{{element.brand | lowercase}}">
                    {{element.brand | uppercase}}
                </mat-chip>
            </td>
        </ng-container>

        <!-- Mass Column -->
        <ng-container matColumnDef="mass">
            <th mat-header-cell *matHeaderCellDef > {{ 'products.table.mass' | translate }}
            </th>
            <td mat-cell *matCellDef="let element">
                <ng-template [ngIf]="editMode">
                    <mat-form-field class="mass-edit-input">
                        <input id="input-mass-{{element.id}}" matInput [ngModel]="element.macros.mass"
                            (ngModelChange)="onMassChange($event, element)" type="number">
                    </mat-form-field>
                    {{element.macros.massUnit}}
                </ng-template>
                <ng-template [ngIf]="!editMode">
                    {{element.macros?.mass}} {{element.macros?.massUnit}}
                </ng-template>
            </td>
        </ng-container>

        <!-- Calories Column -->
        <ng-container matColumnDef="calories">
            <th mat-header-cell *matHeaderCellDef > {{ 'products.table.calories' | translate
                }} </th>
            <td mat-cell *matCellDef="let element"> {{element.macros?.calories | number:'1.1-2'}} </td>
        </ng-container>

        <!-- HC Column -->
        <ng-container matColumnDef="hc">
            <th mat-header-cell *matHeaderCellDef> {{ 'products.table.hc' | translate }}
            </th>
            <td mat-cell *matCellDef="let element"> {{element.macros?.hc | number:'1.1-2'}} </td>
        </ng-container>

        <!-- Fat Column -->
        <ng-container matColumnDef="fats">
            <th mat-header-cell *matHeaderCellDef> {{ 'products.table.fats' | translate }}
            </th>
            <td mat-cell *matCellDef="let element"> {{element.macros?.fats | number:'1.1-2'}} </td>
        </ng-container>

        <!-- Protein Column -->
        <ng-container matColumnDef="proteins">
            <th mat-header-cell *matHeaderCellDef > {{ 'products.table.proteins' | translate
                }} </th>
            <td mat-cell *matCellDef="let element"> {{element.macros?.proteins | number:'1.1-2'}} </td>
        </ng-container>

        <!-- Price Column -->
        <ng-container matColumnDef="price">
            <th mat-header-cell *matHeaderCellDef > {{ 'products.table.price' | translate
                }} </th>
            <td mat-cell *matCellDef="let element"> {{element.prices.length > 0 ? (element.prices[0]?.quantity | number:'1.1-2') : '-'}}€ </td>
        </ng-container>

        <!-- Actions Column -->
        <ng-container *ngIf="hasActions" matColumnDef="actions">
            <th mat-header-cell *matHeaderCellDef > {{ 'products.table.actions' | translate
                }} </th>
            <td mat-cell *matCellDef="let element" class="actions-cell">
                <button mat-icon-button aria-label="Edit product button" [matMenuTriggerFor]="productEd">
                    <mat-icon aria-hidden="false" aria-label="Edit simulation icon"
                        matTooltip="{{ 'actions.edit-simulation' | translate }}" matTooltipPosition="below"
                        class="mr-1">edit</mat-icon>
                </button>

                <mat-menu #productEd="matMenu" [overlapTrigger]="false" class="vy-menu">
                    <button mat-menu-item (click)="editProduct(element)">
                        <span>
                            <strong>Editar producto</strong>
                        </span>
                    </button>
                    <button mat-menu-item (click)="addPrice(element)">
                        <span>
                            <strong>Añadir precio</strong>
                        </span>
                    </button>
                </mat-menu>
            </td>
        </ng-container>


        <tr mat-header-row *matHeaderRowDef="displayedColumns$ | async; sticky: true"></tr>
        <tr mat-row *matRowDef="let row; columns: displayedColumns$ | async;"></tr>
    </table>

</div>